# [DuckChat](https://duckchat.akaxin.com)
<br />
<p align="center"><b>一个安全的私有聊天系统解决方案</b> </p>
<p align="center"><code>私有部署 | 安全可靠 | 随意定制</code></p>
<p align="center"><code>长链接、大集群，支持500+服务器</code> | <code>支持单机部署，非常灵活</code></p>
<p align="center"><code>支持Web端、支持iOS、Android端社交浏览器</code></p>
<p align="center">😀 😁 😂 🤣 😃 😄 😅 😆 😉 😊 😋 😎 😍 😘 😗 </p>
<p align="center"> <b>体验 -> 部署 -> 运营</b></p>

<br />

## 1. 体验


|内容|地址|
|--|--|
|体验站地址（含Web体验）|http://gaga.akaxin.com|
|Android客户端|Android下载：https://duckchat.akaxin.com|
|iOS客户端|iOS下载：[AppStore官方下载 ](https://itunes.apple.com/cn/app/duckchat/id1434153512?l=en&mt=8)|
|官方QQ群|[`QQ5群：131465422`](https://jq.qq.com/?_wv=1027&k=5z7aEG7)|
|官方网站|[DuckChat官方网站 https://duckchat.akaxin.com](https://duckchat.akaxin.com)|




<br />

## 2. 部署

#### 最简单的部署方式

直接当作一个网站，把 `src` 目录中的内容上传至 **网站根目录** 即可。

### 推荐部署方式

|类型|介绍|教程|
|--|--|--|
|Linux|	含Centos、Ubuntu|[一键部署教程](https://duckchat.akaxin.com/wiki/server/docker.md)|
|Windows|	任意 Windows服务器|[一键部署教程](https://duckchat.akaxin.com/wiki/server/windowsInstall.md)|

部署完成后在PC浏览器、手机客户端输入服务器地址即可。

> DuckChat 官方文档: https://duckchat.akaxin.com/wiki/

<br />

## 3. 运营

通过 [DuckChat](https://duckchat.akaxin.com) 强大的扩展能力，以及完善的基础产品，可以快速帮你搭建起一套自己的社交产品，用在企业内部沟通、社交产品创业等场景。

### 企业内部沟通工具

装完即用。

**启动自己的社交产品创业**

1. 构思产品思路
2. 使用 [DuckChat](https://duckchat.akaxin.com) 快速实现思路，先期推广给用户验证商业模式。
    - 同时等待产品技术团队完善自己的产品，产品模式内测、种子用户收集、正式产品开发同步开工，效率极高！
3. 用户多了之后，可以切换到自己正式产品，或者继续使用DuckChat模式。

> 我们提供 `OEM贴牌客户端`，请联系管理员或查看相关文档。

<br />

## 4. 功能列表

[DuckChat](https://duckchat.akaxin.com) 是一款私有的聊天系统解决方案，需要部署在用户自己的服务器上，如此，数据、业务、定制性以及站点的完整控制权均属于用户自己。借助于DuckChat社交浏览器，在iOS、Android也可以获取优异的用户体验。

### 基础消息
| 消息类型 | 描述 |
|:------------- |:--------------- |
| 文本消息	| 已支持 ✓ |
| 图片消息	| 已支持 ✓ |
| 语音消息	| 已支持 ✓ |
| 自定义H5消息 | 已支持 ✓ |
| 文件消息	| 开发中 |
| 视频消息	| 开发中 |
| 地理位置消息 | 开发中 |
| 消息漫游 | 开发中 |

### 群组功能

| 群组功能 | 描述 |
|:------------- |:--------------- |
| 创建群	| 任何人都可以随意创建群聊 |
| 默认群	| 通过管理后台设置默认群，新注册用户自动加群 |	
| 邀请入群	| 只支持邀请方式进群；支持配置：仅管理员可邀请、所有人可邀请 |
| 群容量	| 手机端管理后台设置人数，默认为`100`人 |
| 群资料	| 群公告、群名称等，管理员设置 |
| 成员类型	| 群主、普通成员、发言人 |
| 发言人	| 设置发言人后，只有管理员和发言人可以在发送消息 |
| 管理员	| 可以设置其他成员为管理员 |
| 消息类型	| 与基础消息类型相同 |
| 静音	| 可设置不接受提醒 |
| 踢人	| 群主及管理员可以踢人，且管理员不能踢群主和其他管理员 |
| 主动退群	| 所有人都可以退群 |
| 群主解散群	| 解散此群 |	

### 好友管理

| 好友功能 | 描述 |
|:------------- |:--------------- |
| 搜索用户	| 通过用户登录账号搜索，不可以搜索昵称 |
| 添加好友	| 可以在群中或登录账号搜索进行添加好友 | 
| 默认好友	| 通过管理后台设置默认好友，新注册用户自动互为好友 | 
| 查看好友	| 通过`通讯录`查看好友列表 |
| 删除好友	| 可以在`通讯录`执行删除好友 |

### 管理后台

目前只支持手机端管理后台，Web端不提供管理后台设置。管理员用户在手机端登录站点，点击首页菜单栏的`管理后台`小程序，即可进入管理界面。

| 后台功能 | 描述 |
|:------------- |:--------------- |
| 站点设置	| 设置站点资料、好友模式、群设置、客户端设置等 |
| 小程序管理	| 添加或删除小程序，查看小程序列表，管理小程序资料和权限 | 
| 用户管理	| 用户列表、设置管理员、默认好友、修改资料 | 
| 群组管理	| 群组列表、群资料管理、默认群组、成员管理 |
| 邀请码	| 生成用户注册邀请码，当站点设置为`用邀请码注册`时，由此提供邀请码 |

### 小程序扩展

#### 一、基础小程序

| 展示位置 | 描述 |
|:------------- |:--------------- |
| 默认首页 | 设置为首页小程序，则会以小程序H5页面展示为默认首页 |
| 首页菜单栏 | 小程序列表将会展示在首页上方的菜单栏 |
| 聊天窗口 | 小程序可配置到`表情区域`，用以当做`H5自定义消息`，发送到聊天窗口 |

#### 二、嵌入自己的已有网站，实现与IM整合，例如：

* 用户账号集成
* 用户信息资料获取

集成方式请查阅 [扩展API文档](https://duckchat.akaxin.com/wiki/plugin/)

## OEM合作

DuckChat 致力于构建一个开放的生态体系，现在OEM客户端还在测试阶段，可以获取你专属名称、Logo、启动画面、默认站点的社交浏览器客户端，如果你有需求，请联系管理员。

> 默认站点：社交浏览器客户端，打开后便连接至你的站点。

<br />
<br />

<hr />
<p align="center"><b>一个安全的私有聊天系统解决方案</b> </p>
<p align="center"><code>私有部署 | 安全可靠 | 随意定制</code></p>
<p align="center"><code>长链接、大集群，支持500+服务器</code> | <code>支持单机部署，非常灵活</code></p>
<p align="center"><code>支持Web端、支持iOS、Android端社交浏览器</code></p>
<p align="center">😀 😁 😂 🤣 😃 😄 😅 😆 😉 😊 😋 😎 😍 😘 😗 </p>
<p align="center">更多资料，请前往 <a href="https://duckchat.akaxin.com">DuckChat官网</a> 获取 </p>
